# Decouple Recipe

This recipe is a progressive decoupling tool to help content editors, site builders
and front end developers with limited Drupal expertise to build progressively
decoupled Drupal application.

This recipe includes decouple module.
This module has a new entity "decouple". It enables content editors and site
builders to input information about data from Drupal, and enables front end developers
to input information about root element, JavaScript and CSS file. It automatically
builds a block to host the progressively decoupled Drupal application. The site
builders can use block layout UI to place the block in desired region, for example
content region. When users navigate to the decouple page, the progressively decoupled
Drupal application runs the front end JavaScript using data coming from Drupal.

This recipe includes example to demonstrate how to use decouple module to build
progressively decoupled Drupal application.

## Table of contents

- Installation
- Configuration

## Installation

- Install the Decouple recipe as you would normally install a contributed
  Drupal recipe. See the Recipes [Getting Started Guide](https://git.drupalcode.org/project/distributions_recipes/-/blob/1.0.x/docs/getting_started.md) for further information. We strongly recommend using
  composer to ensure all dependencies will be handled automatically.
- This will import configuration. Once installed, the module provides "decouple"
  node, and provides "Decouple Block" block.

## Configuration

* Navigate to Block Layout (/admin/structure/block).
* Add "Decouple block" block in desired region, for example content region.
* Click `Configure` next to it to enter the block configuration page.
* Turn off "display title".
* Click the `Content types` tab under visibility conditions.
* Select the "decouple" content type to ensure the block is only visible on pages that display nodes of the "decouple" content type.
* Save the Block Configuration.
* Scroll to the bottom of the block layout page and click `Save blocks`.

